/*
 * distributedvideodir.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include <vdr/plugin.h>

static const char *VERSION        = "0.0.4";
static const char *DESCRIPTION    = "Distributed video directory, like in VDR <= 2.1.1 .";
//static const char *MAINMENUENTRY  = "Distributedvideodir";


#include "videodirlinked.h"

// --- cPluginDistributedvideodir -------------------------------------------------------

class cPluginDistributedvideodir : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginDistributedvideodir(void);
  virtual ~cPluginDistributedvideodir();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Stop(void);
  virtual void Housekeeping(void);
  virtual void MainThreadHook(void);
  virtual cString Active(void);
  virtual time_t WakeupTime(void);
//  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  virtual bool Service(const char *Id, void *Data = NULL);
  virtual const char **SVDRPHelpPages(void);
  virtual cString SVDRPCommand(const char *Command, const char *Option, int &ReplyCode);
  };

cPluginDistributedvideodir::cPluginDistributedvideodir(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginDistributedvideodir::~cPluginDistributedvideodir()
{
  // Clean up after yourself!
}

const char *cPluginDistributedvideodir::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginDistributedvideodir::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginDistributedvideodir::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  return true;
}

bool cPluginDistributedvideodir::Start(void)
{
  // Start any background activities the plugin shall perform.

#if (APIVERSNUM >= 20102)
  dsyslog("Plugin Distributedvideodir Start");
  cVideoDirectoryLinked* vdl = new cVideoDirectoryLinked;
  dsyslog("cVideoDirectoryLinked instantiated!");
  
  vdl->LogInfo();
#else
    isyslog("VDR < 2.1.2: No Plugin for Distributedvideodir necessary, not activated!");
#endif
  return true;
}

void cPluginDistributedvideodir::Stop(void)
{
  // Stop any background activities the plugin is performing.
}

void cPluginDistributedvideodir::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

void cPluginDistributedvideodir::MainThreadHook(void)
{
  // Perform actions in the context of the main program thread.
  // WARNING: Use with great care - see PLUGINS.html!
}

cString cPluginDistributedvideodir::Active(void)
{
  // Return a message string if shutdown should be postponed
  return NULL;
}

time_t cPluginDistributedvideodir::WakeupTime(void)
{
  // Return custom wakeup time for shutdown script
  return 0;
}

cOsdObject *cPluginDistributedvideodir::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return NULL;
}

cMenuSetupPage *cPluginDistributedvideodir::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginDistributedvideodir::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

bool cPluginDistributedvideodir::Service(const char *Id, void *Data)
{
  // Handle custom service requests from other plugins
  return false;
}

const char **cPluginDistributedvideodir::SVDRPHelpPages(void)
{
  // Return help text for SVDRP commands this plugin implements
  return NULL;
}

cString cPluginDistributedvideodir::SVDRPCommand(const char *Command, const char *Option, int &ReplyCode)
{
  // Process SVDRP commands this plugin implements
  return NULL;
}

VDRPLUGINCREATOR(cPluginDistributedvideodir); // Don't touch this!
